import {
  Body,
  Controller,
  Delete,
  Get,
  Patch,
  Path,
  Post,
  Request,
  Route,
  Security,
  Tags,
} from "tsoa";
import { AppDataSource } from "../database/data-source";
import {
  CreateProfileEmployeeInsignia,
  ProfileInsignia,
  UpdateProfileInsignia,
} from "../entities/ProfileInsignia";
import HttpSuccess from "../interfaces/http-success";
import HttpStatus from "../interfaces/http-status";
import HttpError from "../interfaces/http-error";
import { ProfileInsigniaHistory } from "../entities/ProfileInsigniaHistory";
import { RequestWithUser } from "../middlewares/user";
import { ProfileEmployee } from "../entities/ProfileEmployee";
import { Insignia } from "../entities/Insignia";
import permission from "../interfaces/permission";
import { setLogDataDiff } from "../interfaces/utils";
@Route("api/v1/org/profile-temp/insignia")
@Tags("ProfileEmployeeInsignia")
@Security("bearerAuth")
export class ProfileInsigniaEmployeeTempController extends Controller {
  private profileEmployeeRepo = AppDataSource.getRepository(ProfileEmployee);
  private insigniaRepo = AppDataSource.getRepository(ProfileInsignia);
  private insigniaHistoryRepo = AppDataSource.getRepository(ProfileInsigniaHistory);
  private insigniaMetaRepo = AppDataSource.getRepository(Insignia);

  @Get("user")
  public async getInsigniaUser(@Request() request: { user: Record<string, any> }) {
    const profile = await this.profileEmployeeRepo.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const record = await this.insigniaRepo.find({
      relations: {
        insignia: {
          insigniaType: true,
        },
      },
      where: { profileEmployeeId: profile.id, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(record);
  }

  @Get("{profileEmployeeId}")
  public async getInsignia(@Path() profileEmployeeId: string, @Request() req: RequestWithUser) {
    let _workflow = await new permission().Workflow(req, profileEmployeeId, "SYS_REGISTRY_TEMP");
    if (_workflow == false) await new permission().PermissionGet(req, "SYS_REGISTRY_TEMP");
    const record = await this.insigniaRepo.find({
      relations: {
        insignia: {
          insigniaType: true,
        },
      },
      where: { profileEmployeeId, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(record);
  }

  @Get("admin/history/{InsigniaId}")
  public async getInsigniaAdminHistory(
    @Path() InsigniaId: string,
    @Request() req: RequestWithUser,
  ) {
    let _workflow = await new permission().Workflow(req, InsigniaId, "SYS_REGISTRY_TEMP");
    if (_workflow == false) await new permission().PermissionGet(req, "SYS_REGISTRY_TEMP");
    const record = await this.insigniaHistoryRepo.find({
      relations: {
        insignia: {
          insigniaType: true,
        },
      },
      where: {
        profileInsigniaId: InsigniaId,
      },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Get("history/{InsigniaId}")
  public async getInsigniaHistory(@Path() InsigniaId: string) {
    const record = await this.insigniaHistoryRepo.find({
      relations: {
        insignia: {
          insigniaType: true,
        },
      },
      where: {
        profileInsigniaId: InsigniaId,
      },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Post()
  public async newInsignia(
    @Request() req: RequestWithUser,
    @Body() body: CreateProfileEmployeeInsignia,
  ) {
    await new permission().PermissionUpdate(req, "SYS_REGISTRY_TEMP");
    if (!body.profileEmployeeId) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "กรุณากรอก profileEmployeeId");
    }

    const profile = await this.profileEmployeeRepo.findOneBy({ id: body.profileEmployeeId });

    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }

    const insignia = await this.insigniaMetaRepo.findOne({
      where: { id: body.insigniaId },
    });
    if (!insignia) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูลเครื่องราชฯ นี้");
    }
    const before = null;
    const data = new ProfileInsignia();

    const meta = {
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    const history = new ProfileInsigniaHistory();
    Object.assign(history, { ...data, id: undefined });

    await this.insigniaRepo.save(data, { data: req });
    setLogDataDiff(req, { before, after: data });
    history.profileInsigniaId = data.id;
    await this.insigniaHistoryRepo.save(history, { data: req });

    return new HttpSuccess(data.id);
  }

  @Patch("{insigniaId}")
  public async editInsignia(
    @Request() req: RequestWithUser,
    @Body() body: UpdateProfileInsignia,
    @Path() insigniaId: string,
  ) {
    await new permission().PermissionUpdate(req, "SYS_REGISTRY_TEMP");
    const record = await this.insigniaRepo.findOneBy({ id: insigniaId });

    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");

    const insignia = await this.insigniaMetaRepo.findOne({
      where: { id: body.insigniaId },
    });
    if (!insignia) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูลเครื่องราชฯ นี้");
    }
    const before = structuredClone(record);
    const history = new ProfileInsigniaHistory();

    Object.assign(record, body);
    Object.assign(history, { ...record, id: undefined });

    history.profileInsigniaId = insigniaId;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = new Date();
    history.lastUpdateUserId = req.user.sub;
    history.lastUpdateFullName = req.user.name;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = new Date();
    history.lastUpdatedAt = new Date();

    this.insigniaRepo.save(record, { data: req });
    setLogDataDiff(req, { before, after: record });
    if (!(Object.keys(body).length === 1 && body.isUpload)) {
      this.insigniaHistoryRepo.save(history, { data: req });
      // setLogDataDiff(req, { before, after: history });
    }

    return new HttpSuccess();
  }

  /**
   * API ลบข้อมูลเครื่องราชอิสริยาภรณ์
   * @summary API ลบข้อมูลเครื่องราชอิสริยาภรณ์
   * @param insigniaId คีย์เครื่องราชอิสริยาภรณ์
   */
  @Patch("update-delete/{insigniaId}")
  public async updateIsDeleted(
    @Request() req: RequestWithUser,
    @Path() insigniaId: string,
  ) {
    const record = await this.insigniaRepo.findOneBy({ id: insigniaId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    if (record.isDeleted === true) {
      return new HttpSuccess();
    }
    await new permission().PermissionDelete(req, "SYS_REGISTRY_TEMP");
    const before = structuredClone(record);
    const history = new ProfileInsigniaHistory();
    const now = new Date();
    record.isDeleted = true;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = now;

    Object.assign(history, { ...record, id: undefined });
    history.profileInsigniaId = insigniaId;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = now;

    await Promise.all([
      this.insigniaRepo.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.insigniaHistoryRepo.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  @Delete("{insigniaId}")
  public async deleteInsignia(@Path() insigniaId: string, @Request() req: RequestWithUser) {
    await new permission().PermissionDelete(req, "SYS_REGISTRY_TEMP");
    await this.insigniaHistoryRepo.delete({
      profileInsigniaId: insigniaId,
    });

    const result = await this.insigniaRepo.delete({ id: insigniaId });

    if (result.affected == undefined || result.affected <= 0) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }

    return new HttpSuccess();
  }
}
